package drew;

import java.beans.*;
import math.*;
import math.pdf.*;
import drew.util.*;

public class GaussianTest implements java.io.Serializable
{
  static final long serialVersionUID = 8636604524219049599L;
  Gaussian gaussian = new Gaussian();

  public GaussianTest()
  {
    gaussian.setDimension(2);
    gaussian.setAutoUpdate(false);
  }


  public Gaussian getGaussian() { return gaussian; }

  IndexedDoubles x = new IndexedDoubles()
  {
    public double ref(int i) { return array[i].ref(0); }
    public int size() { return array.length; }
  };

  IndexedDoubles y = new IndexedDoubles() 
  {
    public double ref(int i) { return array[i].ref(1); }
    public int size() { return array.length; }
  };



  public IndexedDoubles getX()
  {
    return x;
  }

  public IndexedDoubles getY()
  {
    return y;
  }

  Vec[] array = new Vec[100];

  IndexedVecsFromArray samples = new IndexedVecsFromArray(array);

  public IndexedVecs getSamples() 
  { 
    return samples;
  }

  public void update()
  {
    for (int i = 0; i < 100; i++)
      array[i] = gaussian.sample();

    changes.firePropertyChange(this, "x", x, x);
    changes.firePropertyChange(this, "y", y, y);
    changes.firePropertyChange(this, "samples", samples, samples);
  }
  
  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    changes.add(l);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    changes.remove(l);
  }

  private drew.util.EventListenerList changes = new drew.util.EventListenerList();
  
  



}
