package drew;

import drew.figure.*;
import java.beans.*;
import java.lang.reflect.*;

public class IndexedPropertyTester implements java.io.Serializable
{
  private Square[] squares = new Square[0];
  //private Square[] squares;

  public IndexedPropertyTester()
  {
    squares = new Square[3];

    for (int i = 0; i < 3; i++)
      squares[i] = new Square();

    
  }

  // if these signatures are not supplied, will get a PropertyDesciptor
  // and not an IndexedPropertyDescriptor
  // if they are supplied, will be returned by IndexedPropertyDescriptor.getIndexedReadMethod()
  // and getIndexedWriteMethod()

  public void setSquares(int i, Square s)
  {
    squares[i] = s;
  }

  public Square getSquares(int i)
  {
    return squares[i];
  }


  // if these signatures are present, PropertyDesciptor.getReadMethod() and 
  // getWriteMethod() will return them (as will IndexedPropertyDescriptor, a derived
  // class of PropertyDescriptor)

  public void setSquares(Square[] s)
  {
    squares = s;
  }

  public Square[] getSquares()
  {
    System.out.println("getSquares() " + squares.length);
    return squares;
  }

  public void addSquare(Square s)
  {
    setSquares((Square[]) drew.util.ArrayUtil.addElement(squares, s, Square.class));
  }


  // conclusion: if you want it to be recognized as an indexed property, the
  // first form is mandatory.

  public static void main(String[] args)
  {
    PropertyDescriptor pd[];
    try
      {
	BeanInfo bi = Introspector.getBeanInfo(IndexedPropertyTester.class);
	
	pd = bi.getPropertyDescriptors();
      }
    catch (Exception e)
      {
	e.printStackTrace();
      }
	

  }


}

