package drew.editors;

import java.beans.*;
//import scoot.math.linalg.*;
import math.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

public class MatrixEditor extends JTable
  implements PropertyEditor
{
  Matrix value = new Matrix(1,1);
  String txtValue;
  TableModel tableModel;

  public void setValue(Object val)
  {
    if (!(val instanceof Matrix)) return;

    value = (Matrix) val;
    txtValue = value.toString() + " ";

    tableModel = new MyTableModel();
    setModel(tableModel);
    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

    //System.out.println("value.size() == " +
    //value.numRows() + " " + value.numColumns());


    TableColumnModel tcm = getColumnModel();
    
    for (int i = 0; i < tcm.getColumnCount(); i++)
      {
	TableColumn column = tcm.getColumn(i);
	//column.setMinWidth(100);
      }
    int w = getIntercellSpacing().width;
    int h = getIntercellSpacing().height;

    //int scrollWidth = value.numColumns()*tcm.getColumn(0).getWidth()+w*value.numColumns();
    int scrollWidth = value.numColumns()*tcm.getColumn(0).getWidth(); //+w*value.numColumns();
    //int scrollHeight = value.numRows()*getRowHeight()+h*value.numRows();
    int scrollHeight = value.numRows()*getRowHeight(); //+h*value.numRows();


    //int maxWidth = 4*(tcm.getColumn(0).getWidth() + w);
    int maxWidth = 4*(tcm.getColumn(0).getWidth() + 0);

    //int maxHeight = 4*(getRowHeight() + h);
    int maxHeight = 8*(getRowHeight() + 0);
    if (scrollWidth > maxWidth)
      scrollWidth = maxWidth;
    if (scrollHeight > maxHeight)
      scrollHeight = maxHeight;

    setPreferredScrollableViewportSize(new Dimension(scrollWidth, scrollHeight));

    //System.out.println("setValue " + value);
    //invalidate();
  }

  public Object getValue()
  {
    //System.out.println("getValue: " + value);
    return value;
  }

  public boolean isPaintable()
  {
    return true;
  }

  public void paintValue(Graphics g, Rectangle r)
  {
  }

  public boolean supportsCustomEditor()
  {
    return true;
  }

  public Component getCustomEditor()
  {
    //return this;
    return new JScrollPane(this);

  }

  public String[] getTags() {
    return null;
  }

  public String getAsText() {
    return value.toString();
  }
  

  public void setAsText(String s)
  {
  }

  public String getJavaInitializationString()
  {
    return "";
  }
  
  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    support.addPropertyChangeListener(l);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    support.removePropertyChangeListener(l);
  }

  private PropertyChangeSupport support = new PropertyChangeSupport(this);

  

  class MyTableModel extends AbstractTableModel 
  {
    public String getColumnName(int col) { 
      return Integer.toString(col);
    }
    public int getRowCount() { return value.numRows(); }
    public int getColumnCount() { return value.numColumns(); }
    public Object getValueAt(int row, int col) {
      //return new Double(value.ref(row,col));
      return drew.util.Format.formatDouble(value.ref(row,col),4);
    }
    public boolean isCellEditable(int row, int col) { return true; }
    public void setValueAt(Object scalar, int row, int col) 
      {
	Double newDoubleValue = Double.valueOf((String)scalar);
	((Matrix)value).set(row,col,newDoubleValue.doubleValue());
	fireTableCellUpdated(row, col);
	//System.out.println("setValueAt " + value);
	support.firePropertyChange("", null, null);
      }
  }

  public static void main(String[] args)
  {
    JFrame frame = new JFrame();
    VecEditor vecEditor = new VecEditor();
    frame.setContentPane(vecEditor);
    frame.pack();
    frame.setVisible(true);

    vecEditor.setValue(new Vec(4));
  }




}


