package drew.editors;

import java.beans.*;
//import scoot.math.linalg.*;
import math.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

public class VecEditor extends JTable
  implements PropertyEditor
{
  Vec value = new Vec(1);
  String txtValue;
  TableModel tableModel;
  JScrollPane scrollPane;

  public void setValue(Object val)
  {
    if (!(val instanceof Vec)) return;

    value = (Vec) val;
    txtValue = value.toString() + " ";

    tableModel = new MyTableModel();
    setModel(tableModel);
    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

    //System.out.println("value.size() == " + value.size());


    TableColumnModel tcm = getColumnModel();
    
    for (int i = 0; i < tcm.getColumnCount(); i++)
      {
	TableColumn column = tcm.getColumn(i);
	//column.setMinWidth(40);
	//column.setWidth(100);
      }
    int w = getIntercellSpacing().width;

    //int scrollWidth = value.size()*tcm.getColumn(0).getWidth()+w*value.size();
    int scrollWidth = value.size()*tcm.getColumn(0).getWidth();
    
    int scrollHeight = 16;

    //int maxWidth = 4*(tcm.getColumn(0).getWidth() + w);
    int maxWidth = 4*(tcm.getColumn(0).getWidth() + 0);

    if (scrollWidth > maxWidth)
      scrollWidth = maxWidth;

    setPreferredScrollableViewportSize(new Dimension(scrollWidth, scrollHeight));

    //System.out.println("setValue " + value);
    //invalidate();
  }

  public Object getValue()
  {
    System.out.println("getValue: " + value);
    return value;
  }

  public boolean isPaintable()
  {
    return true;
  }

  public void paintValue(Graphics g, Rectangle r)
  {
  }

  public boolean supportsCustomEditor()
  {
    return true;
  }

  public Component getCustomEditor()
  {
    //return this;
    return new JScrollPane(this);

  }

  public String[] getTags() {
    return null;
  }

  public String getAsText() {
    return value.toString();
  }
  

  public void setAsText(String s)
  {
  }

  public String getJavaInitializationString()
  {
    return "";
  }
  
  public void addPropertyChangeListener(PropertyChangeListener l) 
  {
    support.addPropertyChangeListener(l);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener l) 
  {
    support.removePropertyChangeListener(l);
  }

  private PropertyChangeSupport support = new PropertyChangeSupport(this);

  

  class MyTableModel extends AbstractTableModel 
  {
    public String getColumnName(int col) { 
      return Integer.toString(col);
    }
    public int getRowCount() { return 1; }
    public int getColumnCount() { return value.size(); }
    public Object getValueAt(int row, int col) {
      return drew.util.Format.formatDouble(value.ref(col),4);
      //new Double(value.ref(col)); 
    }
    public boolean isCellEditable(int row, int col) { return true; }
    public void setValueAt(Object scalar, int row, int col) 
      {
	Double newDoubleValue = Double.valueOf((String)scalar);
	((Vec)value).set(col,newDoubleValue.doubleValue());
	fireTableCellUpdated(row, col);
	//System.out.println("setValueAt " + value);
	support.firePropertyChange("", null, null);
      }
  }

  public static void main(String[] args)
  {
    JFrame frame = new JFrame();
    VecEditor vecEditor = new VecEditor();
    vecEditor.setValue(new Vec(4));

    frame.setContentPane(vecEditor);
    frame.pack();
    frame.setVisible(true);

  }




}


