package drew.util;

// utility class for making arrays behave a little more 
// like vectors
// so indexed properties aren't so cumbersome
// we use reflection so only have to write these methods once

public class ArrayUtil
{
  public static Object addElement(Object array, Object obj, Class cls)
  {
    int l = java.lang.reflect.Array.getLength(array);
    //Class cls = obj.getClass();
    Object tmp = java.lang.reflect.Array.newInstance(cls, l+1);
    System.arraycopy(array,0,tmp,0,l);
    java.lang.reflect.Array.set(tmp,l,obj);
    return tmp;
  }
  
  public static Object insertElementAt(Object array, Object obj, int i, Class cls)
  {
    int l = java.lang.reflect.Array.getLength(array);
    //Class cls = obj.getClass();
    Object tmp = java.lang.reflect.Array.newInstance(cls, l+1);
    System.arraycopy(array,0,tmp,0,i);
    System.arraycopy(array,i,tmp,i+1,l-i);
    java.lang.reflect.Array.set(tmp,i,obj);
    return tmp;
  }
  
  public static Object removeElementAt(Object array, int i)
  {
    int l = java.lang.reflect.Array.getLength(array);
    Class cls = java.lang.reflect.Array.get(array,i).getClass();
    Object tmp = java.lang.reflect.Array.newInstance(cls, l-1);
    System.arraycopy(array,0,tmp,0,i);
    System.arraycopy(array,i+1,tmp,i,l-i-1);
    return tmp;
  }

  public static boolean contains(Object array, Object obj)
  {
    int l = java.lang.reflect.Array.getLength(array);
    for (int i = 0; i < l; i++)
      if (java.lang.reflect.Array.get(array, i) == obj)
	return true;
    return false;
  }
  



  // tester
  public static void main(String args[])
  {
    Integer[] array = new Integer[3];
    
    for (int i = 0; i < 3; i++)
      array[i] = new Integer(i);

    /*
    array = (Integer[]) insertElementAt(array, new Integer(10), 3);
    for (int i = 0; i < array.length; i++)
      {
	System.out.println(array[i]);
      }
    */
    
    array = (Integer[]) removeElementAt(array, 0);
    for (int i = 0; i < array.length; i++)
      {
	System.out.println(array[i]);
      }

    try { Thread.sleep(10000); } catch (Exception e) {}
  }


}
